// const { existsSync } = require('fs');
// function isTs(api) {
//   const tsPath = api.resolve('src/main.ts')
//   return existsSync(tsPath)
// }

module.exports = api => {
  // 添加项目依赖
  api.extendPackage({
    dependencies: {
      "element-ui": "^2.13.0",
    }
  })
  api.injectImports(api.entryFile, `import ElementUI from 'element-ui';`)
  api.injectImports(api.entryFile, `import 'element-ui/lib/theme-chalk/index.css';`)

  // const antuiFile = isTs(api) ? {
  //   './src/plugins/antui.ts': './templates/src/plugins/antui.ts',
  // } : {
  //   './src/plugins/antui.js': './templates/src/plugins/antui.js',
  // }

  api.render({
    // ...antuiFile,
    './src/App.vue': './templates/src/App.vue',
    './src/components/ComboInput.vue': './templates/src/components/ComboInput.vue',
    './src/components/CustomDialog.vue': './templates/src/components/CustomDialog.vue',
    './src/components/FileSelector.vue': './templates/src/components/FileSelector.vue',
    './src/components/NavMenu.vue': './templates/src/components/NavMenu.vue',
    './src/components/CreateBtn.vue': './templates/src/components/CreateBtn.vue',
    './src/components/DetailsBtn.vue': './templates/src/components/DetailsBtn.vue'
  })

  // 钩子函数
  api.afterInvoke(() => {
    const { EOL } = require('os')
    const fs = require('fs')
    const contentMain = fs.readFileSync(api.resolve(api.entryFile), { encoding: 'utf-8' })
    const lines = contentMain.split(/\r?\n/g)

    // const renderIndex = lines.findIndex(line => line.match(/createApp\(App\)\.mount\('#app'\)/))
    const renderIndex = lines.findIndex(line => line.match(/new Vue/))
    lines[renderIndex-1] = `Vue.use(ElementUI)`
    // lines[renderIndex + 1] = `installAntui(app)`
    // lines[renderIndex + 2] = `app.mount('#app')`

    fs.writeFileSync(api.resolve(api.entryFile), lines.join(EOL), { encoding: 'utf-8' })
  })
}
